<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class Lambda {
	public function __construct(){}
	static function harray($it) {
		$a = new _hx_array(array());
		{
			$i = $it->iterator();
			while($i->hasNext()) {
				$i1 = $i->next();
				$a->push($i1);
				unset($i1);
			}
		}
		return $a;
	}
	static function map($it, $f) {
		$l = new HList();
		{
			$x = $it->iterator();
			while($x->hasNext()) {
				$x1 = $x->next();
				$l->add(call_user_func_array($f, array($x1)));
				unset($x1);
			}
		}
		return $l;
	}
	static function flatten($it) {
		$l = new HList();
		{
			$e = $it->iterator();
			while($e->hasNext()) {
				$e1 = $e->next();
				{
					$x = $e1->iterator();
					while($x->hasNext()) {
						$x1 = $x->next();
						$l->add($x1);
						unset($x1);
					}
					unset($x);
				}
				unset($e1);
			}
		}
		return $l;
	}
	static function flatMap($it, $f) {
		return Lambda::flatten(Lambda::map($it, $f));
	}
	function __toString() { return 'Lambda'; }
}
