<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_events_ABTEventManager {
	public function __construct(){}
	static function _onParticipationCallback() { $args = func_get_args(); return call_user_func_array(self::$_onParticipationCallback, $args); }
	static $_onParticipationCallback;
	static function _onMetadataUpdatedCallback() { $args = func_get_args(); return call_user_func_array(self::$_onMetadataUpdatedCallback, $args); }
	static $_onMetadataUpdatedCallback;
	static function _onParticipatedInExperimentCallback() { $args = func_get_args(); return call_user_func_array(self::$_onParticipatedInExperimentCallback, $args); }
	static $_onParticipatedInExperimentCallback;
	static function _onApptimizeInitializedCallback() { $args = func_get_args(); return call_user_func_array(self::$_onApptimizeInitializedCallback, $args); }
	static $_onApptimizeInitializedCallback;
	static function setOnMetadataUpdatedCallback($updatedCallback) {
		apptimize_events_ABTEventManager::$_onMetadataUpdatedCallback = $updatedCallback;
	}
	static function dispatchOnMetadataUpdated() {
		if(apptimize_events_ABTEventManager::$_onMetadataUpdatedCallback !== null) {
			apptimize_events_ABTEventManager::_onMetadataUpdatedCallback();
		}
	}
	static function setOnParticipationCallback($runCallback) {
		apptimize_events_ABTEventManager::$_onParticipationCallback = $runCallback;
	}
	static function dispatchOnParticipation($experimentName, $variantName) {
		if(apptimize_events_ABTEventManager::$_onParticipationCallback !== null) {
			apptimize_events_ABTEventManager::_onParticipationCallback($experimentName, $variantName);
		}
	}
	static function setOnParticipatedInExperimentCallback($callback) {
		apptimize_events_ABTEventManager::$_onParticipatedInExperimentCallback = $callback;
	}
	static function dispatchOnParticipatedInExperiment($variantInfo, $isFirstParticipation) {
		if(apptimize_events_ABTEventManager::$_onParticipatedInExperimentCallback !== null) {
			apptimize_events_ABTEventManager::_onParticipatedInExperimentCallback($variantInfo, $isFirstParticipation);
		}
		$tmp = $variantInfo->getExperimentName();
		apptimize_events_ABTEventManager::dispatchOnParticipation($tmp, $variantInfo->getVariantName());
	}
	static function setOnApptimizeInitializedCallback($callback) {
		apptimize_events_ABTEventManager::$_onApptimizeInitializedCallback = $callback;
	}
	static function dispatchOnApptimizeInitialized() {
		if(apptimize_events_ABTEventManager::$_onApptimizeInitializedCallback !== null) {
			apptimize_events_ABTEventManager::_onApptimizeInitializedCallback();
		}
	}
	function __toString() { return 'apptimize.events.ABTEventManager'; }
}
