<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_models_ABTAlteration extends apptimize_filter_ABTFilterableObject {
	public function __construct() {
		if(!php_Boot::$skip_constructor) {
		parent::__construct();
	}}
	public $_variant;
	public $_key;
	public function fromJSON($json) {
		parent::fromJSON($json);
	}
	public function selectAlterationsIntoArray($env, $target, $overrideOnly) {
		$match = $this->performFilterMatchingWithEnvironment($env);
		$canSelect = null;
		if(!$match->overriding) {
			$canSelect = !$overrideOnly;
		} else {
			$canSelect = true;
		}
		$selected = null;
		if($canSelect) {
			$selected = (is_object($_t = $match->result) && ($_t instanceof Enum) ? $_t == apptimize_filter_ABTFilterResult::$ABTFilterResultTrue : _hx_equal($_t, apptimize_filter_ABTFilterResult::$ABTFilterResultTrue));
		} else {
			$selected = false;
		}
		if($selected) {
			$tmp = "Selecting alteration \"" . _hx_string_or_null($this->getKey()) . "\" for variant \"";
			$tmp1 = _hx_string_or_null($tmp) . _hx_string_or_null($this->getVariant()->getVariantName()) . "\" for user ";
			$tmp2 = _hx_string_or_null($tmp1) . _hx_string_or_null($env->getUserOrAnonID()) . ".";
			apptimize_ABTLogger::v($tmp2, _hx_anonymous(array("fileName" => "ABTAlteration.hx", "lineNumber" => 50, "className" => "apptimize.models.ABTAlteration", "methodName" => "selectAlterationsIntoArray")));
			$target->push($this);
		}
	}
	public function getKey() {
		return $this->_key;
	}
	public function getVariant() {
		return $this->_variant;
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	static function alterationFromJSON($json, $variant) {
		$classType = apptimize_models_ABTAlteration::classForType(_hx_field($json, "type"));
		$instance = Type::createInstance($classType, (new _hx_array(array())));
		$instance->initialize();
		$instance->fromJSON($json);
		$instance->_variant = $variant;
		return $instance;
	}
	static function classForType($type) {
		if($type === "block") {
			return _hx_qtype("apptimize.models.ABTBlockAlteration");
		}
		return _hx_qtype("apptimize.models.ABTValueAlteration");
	}
	function __toString() { return 'apptimize.models.ABTAlteration'; }
}
