<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_models_ABTValueAlteration extends apptimize_models_ABTAlteration {
	public function __construct() {
		if(!php_Boot::$skip_constructor) {
		parent::__construct();
	}}
	public $_value;
	public $_type;
	public $_nestedType;
	public $_useDefaultValue;
	public function fromJSON($json) {
		parent::fromJSON($json);
		$this->_key = _hx_field($json, "key");
		$this->_value = _hx_field($json, "value");
		$this->_type = _hx_field($json, "type");
		$this->_nestedType = _hx_field($json, "nestedType");
		$this->_useDefaultValue = _hx_field($json, "useDefaultValue");
		$tmp = null;
		if(_hx_field($this, "_value") !== null) {
			$tmp = $this->_type === "dictionary";
		} else {
			$tmp = false;
		}
		if($tmp) {
			$this->_value = apptimize_util_ABTUtilDictionary::dynamicToNativeDictionary($this->_value);
		}
	}
	public function useDefaultValue() {
		return $this->_useDefaultValue;
	}
	public function getValue() {
		return $this->_value;
	}
	public function getType() {
		return $this->_type;
	}
	public function getNestedType() {
		return $this->_nestedType;
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	function __toString() { return 'apptimize.models.ABTValueAlteration'; }
}
