<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_models_ABTVariant extends apptimize_filter_ABTFilterableObject {
	public function __construct($variant) {
		if(!php_Boot::$skip_constructor) {
		parent::__construct();
		$this->fromJSON($variant);
	}}
	public $alterations;
	public $alterations2;
	public $codeBlockName;
	public $experimentId;
	public $experimentName;
	public $experimentType;
	public $startTime;
	public $variantId;
	public $variantName;
	public $cycle;
	public $phase;
	public function fromJSON($obj) {
		parent::fromJSON($obj);
		$variant = $obj;
		$this->alterations = new _hx_array(array());
		$this->alterations2 = new _hx_array(array());
		{
			$_g = 0;
			$_g1 = $variant->alterations;
			while($_g < $_g1->length) {
				$alteration = $_g1[$_g];
				$_g = $_g + 1;
				$tmp = $this->alterations;
				$tmp->push(apptimize_models_ABTAlteration::alterationFromJSON($alteration, $this));
				unset($tmp,$alteration);
			}
		}
		$this->codeBlockName = $variant->codeBlockName;
		if((is_object($_t = Type::getClass($this)) && ($_t instanceof Enum) ? $_t != _hx_qtype("apptimize.models.ABTHotfixVariant") : !_hx_equal($_t, _hx_qtype("apptimize.models.ABTHotfixVariant")))) {
			$this->experimentId = $variant->experimentId;
			$this->experimentName = $variant->experimentName;
			$this->experimentType = $variant->experimentType;
			$this->startTime = $variant->startTime;
			$this->variantName = $variant->variantName;
			$this->variantId = $variant->variantId;
			$this->cycle = $variant->cycle;
			$this->phase = $variant->phase;
		}
		$tmp1 = null;
		if(_hx_has_field($variant, "alterations2")) {
			$tmp1 = $variant->alterations2 !== null;
		} else {
			$tmp1 = false;
		}
		if($tmp1) {
			{
				$_g2 = 0;
				$_g11 = $variant->alterations2;
				while($_g2 < $_g11->length) {
					$alteration1 = $_g11[$_g2];
					$_g2 = $_g2 + 1;
					$tmp2 = $this->alterations2;
					$tmp2->push(apptimize_models_ABTAlteration::alterationFromJSON($alteration1, $this));
					unset($tmp2,$alteration1);
				}
			}
			$this->alterations = $this->alterations->concat($this->alterations2);
		}
	}
	public function selectAlterationsIntoArray($env, $target, $overrideOnly) {
		$match = $this->performFilterMatchingWithEnvironment($env);
		if((is_object($_t = $match->result) && ($_t instanceof Enum) ? $_t != apptimize_filter_ABTFilterResult::$ABTFilterResultTrue : !_hx_equal($_t, apptimize_filter_ABTFilterResult::$ABTFilterResultTrue))) {
			return;
		}
		$newOverrideOnly = $this->computeNewOverrideState($overrideOnly, $match);
		{
			$_g = 0;
			$_g1 = $this->alterations;
			while($_g < $_g1->length) {
				$alteration = $_g1[$_g];
				$_g = $_g + 1;
				$alteration->selectAlterationsIntoArray($env, $target, $newOverrideOnly);
				unset($alteration);
			}
		}
	}
	public function getVariantID() {
		return $this->variantId;
	}
	public function getVariantName() {
		return $this->variantName;
	}
	public function getExperimentID() {
		return $this->experimentId;
	}
	public function getExperimentName() {
		return $this->experimentName;
	}
	public function getExperimentType() {
		return $this->experimentType;
	}
	public function getCodeBlockName() {
		return $this->codeBlockName;
	}
	public function getPhase() {
		return $this->phase;
	}
	public function getCycle() {
		return $this->cycle;
	}
	public function getUrlKeyProviders() {
		return $this->asUrlProviders($this->alterations);
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	function __toString() { return 'apptimize.models.ABTVariant'; }
}
