<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_models_results_ABTResultEntryVariantShown extends apptimize_models_results_ABTResultEntry {
	public function __construct($env, $variantID, $cycle, $phase) {
		if(!php_Boot::$skip_constructor) {
		$this->_type = "v";
		parent::__construct($env);
		$this->_variantID = $variantID;
		$this->_cycle = $cycle;
		$this->_phase = $phase;
	}}
	public $_type;
	public $_variantID;
	public $_cycle;
	public $_phase;
	public function JSONRepresentation() {
		$jsonDict = parent::JSONRepresentation();
		{
			$v = $this->_type;
			$jsonDict->set("ty", $v);
		}
		{
			$v1 = $this->_variantID;
			$jsonDict->set("v", $v1);
		}
		{
			$_g = new haxe_ds_StringMap();
			$_g->set("v", $this->_variantID);
			$_g->set("c", $this->_cycle);
			$_g->set("p", $this->_phase);
			$v2 = $_g;
			$jsonDict->set("vp", $v2);
		}
		return $jsonDict;
	}
	public function hxSerialize($s) {
		parent::hxSerialize($s);
		$s->serialize($this->_type);
		$s->serialize($this->_variantID);
		$s->serialize($this->_cycle);
		$s->serialize($this->_phase);
	}
	public function hxUnserialize($u) {
		parent::hxUnserialize($u);
		$this->_type = $u->unserialize();
		$this->_variantID = $u->unserialize();
		$this->_cycle = $u->unserialize();
		$this->_phase = $u->unserialize();
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	function __toString() { return 'apptimize.models.results.ABTResultEntryVariantShown'; }
}
