<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_models_results_ABTResultLog {
	public function __construct($env) {
		if(!php_Boot::$skip_constructor) {
		if($env !== null) {
			$this->userID = $env->userID;
			$this->anonID = $env->anonID;
			$this->appkey = $env->appkey;
			$this->uniqueID = $env->getUniqueUserID();
		}
		$this->entries = new _hx_array(array());
	}}
	public $entries;
	public $userID;
	public $anonID;
	public $appkey;
	public $uniqueID;
	public function logEntry($entry) {
		$this->entries->push($entry);
	}
	public function entryCount() {
		return $this->entries->length;
	}
	public function getAppKey() {
		return $this->appkey;
	}
	public function getUniqueUserKey() {
		return $this->uniqueID;
	}
	public function toJSON() {
		$json = new haxe_ds_StringMap();
		$jsonEntries = new _hx_array(array());
		{
			$_g = 0;
			$_g1 = $this->entries;
			while($_g < $_g1->length) {
				$entry = $_g1[$_g];
				$_g = $_g + 1;
				$jsonEntries->push($entry->JSONRepresentation());
				unset($entry);
			}
		}
		{
			$v = "v4";
			$json->set("type", $v);
		}
		{
			$v1 = $this->getAppKey();
			$json->set("a", $v1);
		}
		{
			$v2 = apptimize_ABTDataStore::getServerGUID();
			$json->set("g", $v2);
		}
		$currentDate = Date::now();
		$nowMs = haxe_Int64Helper::fromFloat(Date::now()->getTime());
		{
			$v3 = apptimize_util_ABTInt64Utils::toPreprocessedString($nowMs);
			$json->set("c", $v3);
		}
		{
			$v4 = $jsonEntries;
			$json->set("e", $v4);
		}
		{
			$v5 = "Cross Platform " . _hx_string_or_null(apptimize_Apptimize::getApptimizeSDKVersion());
			$json->set("v", $v5);
		}
		if($this->userID !== null) {
			$v6 = $this->userID;
			$json->set("u", $v6);
		}
		return apptimize_util_ABTJSONUtils::stringify($json);
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	function __toString() { return 'apptimize.models.results.ABTResultLog'; }
}
