<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_support_persistence_ABTPersistentInterface {
	public function __construct(){}
	public function save($key, $value, $latency = null, $compress = null) {
		if($compress === null) {
			$compress = false;
		}
		if($latency === null) {
			$latency = 0;
		}
		throw new HException("ABTPersistentInterface.save not implemented");
	}
	public function load($key, $latency = null, $callback = null) {
		if($latency === null) {
			$latency = 0;
		}
		throw new HException("ABTPersistentInterface.load not implemented");
	}
	public function clear($latency = null) {
		if($latency === null) {
			$latency = 2;
		}
	}
	public function saveObject($key, $value, $latency = null, $compress = null) {
		if($compress === null) {
			$compress = false;
		}
		if($latency === null) {
			$latency = 0;
		}
		$serializer = new haxe_Serializer();
		$serializer->serialize($value);
		$serializer->serialize(apptimize_Apptimize::getApptimizeSDKVersion());
		$this->save($key, $serializer->toString(), $latency, $compress);
	}
	public function loadObject($key, $latency = null, $callback = null) {
		if($latency === null) {
			$latency = 0;
		}
		$_gthis = $this;
		$result = null;
		$processObject = array(new _hx_lambda(array(&$_gthis, &$callback, &$result), "apptimize_support_persistence_ABTPersistentInterface_0"), 'execute');
		if($callback !== null) {
			return $this->load($key, $latency, $processObject);
		} else {
			$serializedObject1 = $this->load($key, $latency, $callback);
			return call_user_func_array($processObject, array($key, $serializedObject1));
		}
	}
	public function sync($key, $fromLatency, $toLatency, $callback = null) {
		$onCallback = array(new _hx_lambda(array(&$callback), "apptimize_support_persistence_ABTPersistentInterface_1"), 'execute');
		$this->loadObject($key, $fromLatency, $onCallback);
	}
	public function hasDidUnserialize($obj) {
		return _hx_field($obj, "didUnserialize") !== null;
	}
	function __toString() { return 'apptimize.support.persistence.ABTPersistentInterface'; }
}
function apptimize_support_persistence_ABTPersistentInterface_0(&$_gthis, &$callback, &$result, $key1, $serializedObject) {
	{
		if($serializedObject !== null) {
			try {
				$unserializer = new haxe_Unserializer($serializedObject);
				$result = $unserializer->unserialize();
				$processObject1 = null;
				if($result !== null) {
					$processObject1 = $_gthis->hasDidUnserialize($result);
				} else {
					$processObject1 = false;
				}
				if($processObject1) {
					$result->didUnserialize();
				}
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				$unknown = $_ex_;
				{
					$processObject2 = "Error deserializing \"" . _hx_string_or_null($key1) . "\" from persistent storage. Error: " . Std::string($unknown);
					apptimize_ABTLogger::e($processObject2, _hx_anonymous(array("fileName" => "ABTPersistence.hx", "lineNumber" => 50, "className" => "apptimize.support.persistence.ABTPersistentInterface", "methodName" => "loadObject")));
				}
			}
			if($callback !== null) {
				call_user_func_array($callback, array($key1, $result));
				return $result;
			}
		}
		if($callback !== null) {
			call_user_func_array($callback, array($key1, null));
		}
		return $result;
	}
}
function apptimize_support_persistence_ABTPersistentInterface_1(&$callback, $key1, $value) {
	{
		if($callback !== null) {
			call_user_func_array($callback, array($key1, $value));
		}
	}
}
