<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_support_properties_ABTConfigProperties extends apptimize_support_properties_ABTProperties {
	public function __construct() { if(!php_Boot::$skip_constructor) {
		parent::__construct();
	}}
	public function setPropertyDefaults() {
		$this->availableProperties->set(apptimize_support_properties_ABTConfigProperties::$META_DATA_URL_LL_KEY, "https://md-ll.apptimize.com/api/metadata/v4/");
		$this->availableProperties->set(apptimize_support_properties_ABTConfigProperties::$META_DATA_URL_HL_KEY, "https://md-hl.apptimize.com/api/metadata/v4/");
		$this->availableProperties->set(apptimize_support_properties_ABTConfigProperties::$META_DATA_URL_KEY, null);
		$this->availableProperties->set(apptimize_support_properties_ABTConfigProperties::$LOG_LEVEL_KEY, "LOG_LEVEL_WARN");
		$this->availableProperties->set(apptimize_support_properties_ABTConfigProperties::$FOREGROUND_PERIOD_MS_KEY, 10000);
		$this->availableProperties->set(apptimize_support_properties_ABTConfigProperties::$RESULT_POST_DELAY_MS_KEY, 60000);
		$this->availableProperties->set(apptimize_support_properties_ABTConfigProperties::$ALTERATION_CACHE_SIZE_KEY, 10);
		$this->availableProperties->set(apptimize_support_properties_ABTConfigProperties::$RESULTS_CACHE_SIZE_KEY, 10);
		$this->availableProperties->set(apptimize_support_properties_ABTConfigProperties::$MAXIMUM_RESULT_ENTRIES_KEY, 1000);
		$this->availableProperties->set(apptimize_support_properties_ABTConfigProperties::$MAXIMUM_PENDING_RESULTS_KEY, 1000);
		$this->availableProperties->set(apptimize_support_properties_ABTConfigProperties::$METADATA_POLLING_INTERVAL_MS_KEY, 600000);
		$this->availableProperties->set(apptimize_support_properties_ABTConfigProperties::$MAXIMUM_RESULT_POST_FAILURE_KEY, 3);
		$this->availableProperties->set(apptimize_support_properties_ABTConfigProperties::$MAXIMUM_RESULT_POST_SENDER_TIMEOUT_MS_KEY, 3000);
		$this->availableProperties->set(apptimize_support_properties_ABTConfigProperties::$METADATA_POLLING_BACKGROUND_INTERVAL_MS_KEY, 86400000);
		$this->availableProperties->set(apptimize_support_properties_ABTConfigProperties::$STORAGE_TYPE_KEY, null);
		$this->availableProperties->set(apptimize_support_properties_ABTConfigProperties::$APPTIMIZE_ENVIRONMENT_KEY, null);
		$this->availableProperties->set(apptimize_support_properties_ABTConfigProperties::$AUTOMATIC_SHUTDOWN_HOOK, true);
		$this->availableProperties->set(apptimize_support_properties_ABTConfigProperties::$GROUPS_BASE_URL_KEY, "https://mapi.apptimize.com");
		$this->availableProperties->set(apptimize_support_properties_ABTConfigProperties::$LOCAL_DISK_STORAGE_PATH_KEY, "data/apptimize/");
		$this->availableProperties->set(apptimize_support_properties_ABTConfigProperties::$REACT_NATIVE_STORAGE_KEY, null);
		$this->availableProperties->set(apptimize_support_properties_ABTConfigProperties::$THREADING_ENABLED_KEY, true);
		$this->availableProperties->set(apptimize_support_properties_ABTConfigProperties::$RESULT_POST_THREAD_POOL_SIZE_KEY, 20);
		$this->availableProperties->set(apptimize_support_properties_ABTConfigProperties::$EXCEPTIONS_ENABLED_KEY, false);
		$this->availableProperties->set(apptimize_support_properties_ABTConfigProperties::$COMPRESS_PERSISTENCE_STORE_KEY, false);
	}
	static $META_DATA_URL_KEY = "meta_data_url";
	static $META_DATA_URL_LL_KEY = "meta_data_ll_url";
	static $META_DATA_URL_HL_KEY = "meta_data_hl_url";
	static $LOG_LEVEL_KEY = "log_level";
	static $FOREGROUND_PERIOD_MS_KEY = "foreground_period_ms";
	static $RESULT_POST_DELAY_MS_KEY = "result_post_delay_ms";
	static $THREADING_ENABLED_KEY = "threading_enabled";
	static $RESULT_POST_THREAD_POOL_SIZE_KEY = "result_post_thread_pool_size";
	static $ALTERATION_CACHE_SIZE_KEY = "alteration_cache_size";
	static $RESULTS_CACHE_SIZE_KEY = "results_cache_size";
	static $MAXIMUM_RESULT_ENTRIES_KEY = "maximum_result_entries";
	static $MAXIMUM_PENDING_RESULTS_KEY = "maximum_pending_results";
	static $METADATA_POLLING_INTERVAL_MS_KEY = "metadata_polling_interval_ms";
	static $METADATA_POLLING_BACKGROUND_INTERVAL_MS_KEY = "metadata_polling_background_interval_ms";
	static $EXCEPTIONS_ENABLED_KEY = "exceptions_enabled";
	static $MAXIMUM_RESULT_POST_FAILURE_KEY = "maximum_result_failures";
	static $MAXIMUM_RESULT_POST_SENDER_TIMEOUT_MS_KEY = "maximum_result_post_sender_timeout_ms";
	static $STORAGE_TYPE_KEY = "storage_type";
	static $AUTOMATIC_SHUTDOWN_HOOK = "automatic_shutdown_hook";
	static $APPTIMIZE_ENVIRONMENT_KEY = "apptimize_environment";
	static $APPTIMIZE_REGION_KEY = "apptimize_region";
	static $COMPRESS_PERSISTENCE_STORE_KEY = "compress_persistence_store";
	static $GROUPS_BASE_URL_KEY = "groups_base_url";
	static $REACT_NATIVE_STORAGE_KEY = "react_native_storage";
	static $LOCAL_DISK_STORAGE_PATH_KEY = "local_disk_storage_path";
	static $_instance;
	static function sharedInstance() {
		if(apptimize_support_properties_ABTConfigProperties::$_instance === null) {
			apptimize_support_properties_ABTConfigProperties::$_instance = new apptimize_support_properties_ABTConfigProperties();
		}
		return apptimize_support_properties_ABTConfigProperties::$_instance;
	}
	function __toString() { return 'apptimize.support.properties.ABTConfigProperties'; }
}
