<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_support_properties_ABTCustomProperties extends apptimize_support_properties_ABTProperties {
	public function __construct() { if(!php_Boot::$skip_constructor) {
		parent::__construct();
	}}
	public function setPropertyDefaults() {}
	public function setProperty($key, $value) {
		$this->setPropertyForNamespace($key, $value, apptimize_support_properties_CustomPropertyNamespace::$UserAttribute);
	}
	public function setPropertyForNamespace($key, $value, $namespace) {
		parent::setProperty(_hx_string_or_null($this->sigilForNamespace($namespace)) . _hx_string_or_null($key),$value);
	}
	public function sigilForNamespace($namespace) {
		switch($namespace->index) {
		case 0:{
			return "%";
		}break;
		case 1:{
			return "l";
		}break;
		case 2:{
			return "^";
		}break;
		}
	}
	public function valueForNamespacedProperty($propertyName, $namespace) {
		return parent::valueForProperty(_hx_string_or_null($this->sigilForNamespace($namespace)) . _hx_string_or_null($propertyName));
	}
	public function addJSONProperties($jsonProperties) {
		$key = $this->availableProperties->keys();
		while($key->hasNext()) {
			$key1 = $key->next();
			$tmp = _hx_char_at($key1, 0);
			if($tmp !== $this->sigilForNamespace(apptimize_support_properties_CustomPropertyNamespace::$ApptimizeLocal)) {
				$v = $this->availableProperties->get($key1);
				$jsonProperties->set($key1, $v);
				unset($v);
			}
			unset($tmp,$key1);
		}
	}
	function __toString() { return 'apptimize.support.properties.ABTCustomProperties'; }
}
