<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_support_properties_ABTInternalProperties extends apptimize_support_properties_ABTCustomProperties {
	public function __construct() { if(!php_Boot::$skip_constructor) {
		parent::__construct();
	}}
	public function isPropertyAvailable($propertyName) {
		$this->_loadProperties();
		return parent::isPropertyAvailable($propertyName);
	}
	public function valueForProperty($propertyName) {
		$this->_loadProperties();
		return $this->availableProperties->get($propertyName);
	}
	public function setProperty($key, $value) {
		$this->setPropertyForNamespace($key, $value, apptimize_support_properties_CustomPropertyNamespace::$ApptimizeInternal);
	}
	public function _loadProperties() {
		$this->availableProperties = apptimize_support_persistence_ABTPersistence::loadObject(apptimize_support_persistence_ABTPersistence::$kInternalPropertiesKey, null);
		if($this->availableProperties === null) {
			$this->availableProperties = new haxe_ds_StringMap();
		}
	}
	public function _saveProperties() {
		apptimize_support_persistence_ABTPersistence::saveObject(apptimize_support_persistence_ABTPersistence::$kInternalPropertiesKey, $this->availableProperties, null, null);
	}
	public function setPropertyForNamespace($key, $value, $namespace) {
		$this->_loadProperties();
		parent::setPropertyForNamespace($key,$value,$namespace);
		$this->_saveProperties();
	}
	public function valueForNamespacedProperty($propertyName, $namespace) {
		$this->_loadProperties();
		return parent::valueForNamespacedProperty($propertyName,$namespace);
	}
	static $_instance;
	static function sharedInstance() {
		if(apptimize_support_properties_ABTInternalProperties::$_instance === null) {
			apptimize_support_properties_ABTInternalProperties::$_instance = new apptimize_support_properties_ABTInternalProperties();
		}
		return apptimize_support_properties_ABTInternalProperties::$_instance;
	}
	function __toString() { return 'apptimize.support.properties.ABTInternalProperties'; }
}
