<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_util_ABTDataLock {
	public function __construct(){}
	static $SYSTEM_DATA_LOCK;
	static $METADATA_LOCK;
	static $CHECK_TIME_LOCK;
	static $INITIALIZATION;
	static function getNewLock($lockName) {
		return new apptimize_util_PHPPlatformLock($lockName);
	}
	function __toString() { return 'apptimize.util.ABTDataLock'; }
}
apptimize_util_ABTDataLock::$SYSTEM_DATA_LOCK = apptimize_util_ABTDataLock::getNewLock("system_data_lock");
apptimize_util_ABTDataLock::$METADATA_LOCK = apptimize_util_ABTDataLock::getNewLock("meta_data_lock");
apptimize_util_ABTDataLock::$CHECK_TIME_LOCK = apptimize_util_ABTDataLock::getNewLock("last_check_time_lock");
apptimize_util_ABTDataLock::$INITIALIZATION = apptimize_util_ABTDataLock::getNewLock("initialize_lock");
