<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_util_ABTUtilGzip {
	public function __construct(){}
	static function jsonSignatureLength($bytes) {
		$b = haxe_io_Bytes::ofData($bytes);
		$this1 = $b->b;
		$len = ord($this1->s[0]) << 8;
		$this2 = $b->b;
		$len1 = $len | ord($this2->s[1]);
		return $len1;
	}
	static function decompressBytes($bytes) {
		sys_io_File::saveBytes("data/apptimize/tmp.zip", $bytes);
		$tmpFileStream = sys_io_File::read("data/apptimize/tmp.zip", null);
		$output = new format_gz_Reader($tmpFileStream);
		$responseOut = $output->read();
		$tmpFileStream->close();
		unlink("data/apptimize/tmp.zip");
		return $responseOut->data;
	}
	static function decompress($bytes) {
		$bds = haxe_io_Bytes::ofData($bytes);
		$len = apptimize_util_ABTUtilGzip::jsonSignatureLength($bytes);
		$dataLength = $bds->length;
		$sigLength = $len + 2;
		$zippedLength = $dataLength - $sigLength;
		$orig = haxe_io_Bytes::ofData($bytes);
		$bd = $orig->sub($sigLength, $zippedLength);
		return apptimize_util_ABTUtilGzip::decompressBytes($bd);
	}
	function __toString() { return 'apptimize.util.ABTUtilGzip'; }
}
