<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class haxe_EntryPoint {
	public function __construct(){}
	static $sleepLock;
	static $mutex;
	static $pending;
	static $threadCount = 0;
	static function processEvents() {
		while(true) {
			$_this = haxe_EntryPoint::$mutex;
			$f = haxe_EntryPoint::$pending->shift();
			$_this1 = haxe_EntryPoint::$mutex;
			if($f === null) {
				break;
			}
			call_user_func($f);
			unset($f,$_this1,$_this);
		}
		$tmp = null;
		if(haxe_MainLoop::$pending === null) {
			$tmp = haxe_EntryPoint::$threadCount === 0;
		} else {
			$tmp = false;
		}
		if($tmp) {
			return -1;
		}
		return haxe_MainLoop::tick();
	}
	static function run() {
		while(true) {
			$nextTick = haxe_EntryPoint::processEvents();
			if($nextTick < 0) {
				break;
			}
			if($nextTick > 0) {
				$_this = haxe_EntryPoint::$sleepLock;
				unset($_this);
			}
			unset($nextTick);
		}
	}
	function __toString() { return 'haxe.EntryPoint'; }
}
haxe_EntryPoint::$sleepLock = new haxe__EntryPoint_Lock();
haxe_EntryPoint::$mutex = new haxe__EntryPoint_Mutex();
haxe_EntryPoint::$pending = new _hx_array(array());
