<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class hx_concurrent_collection__SynchronizedLinkedList_SynchronizedLinkedListImpl implements hx_concurrent_collection_OrderedCollection{
	public function __construct() {
		if(!php_Boot::$skip_constructor) {
		$this->_sync = new hx_concurrent_lock_RLock();
		$this->_items = new HList();
	}}
	public $_items;
	public $_sync;
	public function add($item) {
		$_gthis = $this;
		$this->_sync->execute(array(new _hx_lambda(array(&$_gthis, &$item), "hx_concurrent_collection__SynchronizedLinkedList_SynchronizedLinkedListImpl_0"), 'execute'), null);
	}
	public function addAll($coll) {
		$_gthis = $this;
		$this->_sync->execute(array(new _hx_lambda(array(&$_gthis, &$coll), "hx_concurrent_collection__SynchronizedLinkedList_SynchronizedLinkedListImpl_1"), 'execute'), null);
	}
	public function remove($x) {
		$_gthis = $this;
		return $this->_sync->execute(array(new _hx_lambda(array(&$_gthis, &$x), "hx_concurrent_collection__SynchronizedLinkedList_SynchronizedLinkedListImpl_2"), 'execute'), null);
	}
	public function indexOf($x, $startAt = null) {
		if($startAt === null) {
			$startAt = 0;
		}
		$_gthis = $this;
		return $this->_sync->execute(array(new _hx_lambda(array(&$_gthis, &$startAt, &$x), "hx_concurrent_collection__SynchronizedLinkedList_SynchronizedLinkedListImpl_3"), 'execute'), null);
	}
	public function iterator() {
		$_gthis = $this;
		return $this->_sync->execute(array(new _hx_lambda(array(&$_gthis), "hx_concurrent_collection__SynchronizedLinkedList_SynchronizedLinkedListImpl_4"), 'execute'), null);
	}
	public function toArray() {
		$_gthis = $this;
		return $this->_sync->execute(array(new _hx_lambda(array(&$_gthis), "hx_concurrent_collection__SynchronizedLinkedList_SynchronizedLinkedListImpl_5"), 'execute'), null);
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	function __toString() { return 'hx.concurrent.collection._SynchronizedLinkedList.SynchronizedLinkedListImpl'; }
}
function hx_concurrent_collection__SynchronizedLinkedList_SynchronizedLinkedListImpl_0(&$_gthis, &$item) {
	{
		$_gthis->_items->add($item);
	}
}
function hx_concurrent_collection__SynchronizedLinkedList_SynchronizedLinkedListImpl_1(&$_gthis, &$coll) {
	{
		$_g = $coll;
		switch($_g->index) {
		case 0:{
			$coll1 = _hx_deref($_g)->params[0];
			{
				$i = $coll1->iterator();
				while($i->hasNext()) {
					$i1 = $i->next();
					$_gthis->_items->add($i1);
					unset($i1);
				}
			}
		}break;
		case 1:{
			$arr = _hx_deref($_g)->params[0];
			{
				$_g1 = 0;
				while($_g1 < $arr->length) {
					$i2 = $arr[$_g1];
					$_g1 = $_g1 + 1;
					$_gthis->_items->add($i2);
					unset($i2);
				}
			}
		}break;
		case 2:{
			$list = _hx_deref($_g)->params[0];
			{
				$i3 = $list->iterator();
				while($i3->hasNext()) {
					$i4 = $i3->next();
					$_gthis->_items->add($i4);
					unset($i4);
				}
			}
		}break;
		}
	}
}
function hx_concurrent_collection__SynchronizedLinkedList_SynchronizedLinkedListImpl_2(&$_gthis, &$x) {
	{
		if($_gthis->indexOf($x, null) === -1) {
			return false;
		}
		return $_gthis->_items->remove($x);
	}
}
function hx_concurrent_collection__SynchronizedLinkedList_SynchronizedLinkedListImpl_3(&$_gthis, &$startAt, &$x) {
	{
		$i = 0;
		{
			$item = $_gthis->_items->iterator();
			while($item->hasNext()) {
				$item1 = $item->next();
				$tmp = null;
				if($i >= $startAt) {
					$tmp = (is_object($_t = $item1) && ($_t instanceof Enum) ? $_t == $x : _hx_equal($_t, $x));
					unset($_t);
				} else {
					$tmp = false;
				}
				if($tmp) {
					return $i;
				}
				$i = $i + 1;
				unset($tmp,$item1);
			}
		}
		return -1;
	}
}
function hx_concurrent_collection__SynchronizedLinkedList_SynchronizedLinkedListImpl_4(&$_gthis) {
	{
		return $_gthis->_items->iterator();
	}
}
function hx_concurrent_collection__SynchronizedLinkedList_SynchronizedLinkedListImpl_5(&$_gthis) {
	{
		$arr = new _hx_array(array());
		{
			$item = $_gthis->_items->iterator();
			while($item->hasNext()) {
				$item1 = $item->next();
				$arr->push($item1);
				unset($item1);
			}
		}
		return $arr;
	}
}
