<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_filter_ABTCompoundFilter extends apptimize_filter_ABTFilter {
	public function __construct() { if(!php_Boot::$skip_constructor) {
		parent::__construct();
	}}
	public function fromJSON($json) {
		parent::fromJSON($json);
		$filtersArray = new _hx_array(array());
		$dynamicArray = _hx_field($json, "value");
		{
			$_g = 0;
			while($_g < $dynamicArray->length) {
				$filter = $dynamicArray[$_g];
				$_g = $_g + 1;
				$ff = apptimize_filter_ABTFilter::filterFromJSON($filter);
				$filtersArray->push($ff);
				unset($filter,$ff);
			}
		}
		$this->value = $filtersArray;
	}
	public function filterMatchesEnvironment($env) {
		$children = $this->value;
		if($children->length < 1) {
			$tmp = "Compound filter \"" . Std::string($this) . "\" has an empty compound set. Filter match is unknown.";
			apptimize_ABTLogger::w($tmp, _hx_anonymous(array("fileName" => "ABTFilter.hx", "lineNumber" => 407, "className" => "apptimize.filter.ABTCompoundFilter", "methodName" => "filterMatchesEnvironment")));
			return apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown;
		}
		if((is_object($_t = $this->filterOperator) && ($_t instanceof Enum) ? $_t == apptimize_filter_ABTFilterOperator::$ABTFilterOperatorCompoundAnd : _hx_equal($_t, apptimize_filter_ABTFilterOperator::$ABTFilterOperatorCompoundAnd))) {
			$result = apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			{
				$_g = 0;
				while($_g < $children->length) {
					$filter = $children[$_g];
					$_g = $_g + 1;
					$currentResult = $filter->filterMatchesEnvironment($env);
					$result = apptimize_filter_ABTFilterUtils::ABTFilterAnd($result, $currentResult);
					unset($filter,$currentResult);
				}
			}
			return $result;
		}
		if((is_object($_t2 = $this->filterOperator) && ($_t2 instanceof Enum) ? $_t2 == apptimize_filter_ABTFilterOperator::$ABTFilterOperatorCompoundOr : _hx_equal($_t2, apptimize_filter_ABTFilterOperator::$ABTFilterOperatorCompoundOr))) {
			$result1 = apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
			{
				$_g1 = 0;
				while($_g1 < $children->length) {
					$filter1 = $children[$_g1];
					$_g1 = $_g1 + 1;
					$currentResult1 = $filter1->filterMatchesEnvironment($env);
					$result1 = apptimize_filter_ABTFilterUtils::ABTFilterOr($result1, $currentResult1);
					unset($filter1,$currentResult1);
				}
			}
			return $result1;
		}
		$tmp1 = null;
		if((is_object($_t3 = $this->filterOperator) && ($_t3 instanceof Enum) ? $_t3 == apptimize_filter_ABTFilterOperator::$ABTFilterOperatorCompoundSingleNot : _hx_equal($_t3, apptimize_filter_ABTFilterOperator::$ABTFilterOperatorCompoundSingleNot))) {
			$tmp1 = $children->length === 1;
		} else {
			$tmp1 = false;
		}
		if($tmp1) {
			$child = $children[0];
			$result2 = $child->filterMatchesEnvironment($env);
			if($result2 === apptimize_filter_ABTFilterResult::$ABTFilterResultFalse) {
				$result2 = apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			} else {
				if($result2 === apptimize_filter_ABTFilterResult::$ABTFilterResultTrue) {
					$result2 = apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
				}
			}
			return $result2;
		}
		$tmp2 = null;
		if((is_object($_t4 = $this->filterOperator) && ($_t4 instanceof Enum) ? $_t4 == apptimize_filter_ABTFilterOperator::$ABTFilterOperatorCompoundSingleIsNull : _hx_equal($_t4, apptimize_filter_ABTFilterOperator::$ABTFilterOperatorCompoundSingleIsNull))) {
			$tmp2 = $children->length === 1;
		} else {
			$tmp2 = false;
		}
		if($tmp2) {
			$child1 = $children[0];
			$result3 = null;
			if((is_object($_t5 = $child1->filterMatchesEnvironment($env)) && ($_t5 instanceof Enum) ? $_t5 == apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown : _hx_equal($_t5, apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown))) {
				$result3 = apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			} else {
				$result3 = apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
			}
			return $result3;
		}
		$tmp3 = null;
		if((is_object($_t5 = $this->filterOperator) && ($_t5 instanceof Enum) ? $_t5 == apptimize_filter_ABTFilterOperator::$ABTFilterOperatorCompoundSingleIsNotNull : _hx_equal($_t5, apptimize_filter_ABTFilterOperator::$ABTFilterOperatorCompoundSingleIsNotNull))) {
			$tmp3 = $children->length === 1;
		} else {
			$tmp3 = false;
		}
		if($tmp3) {
			$child2 = $children[0];
			if((is_object($_t6 = $child2->filterMatchesEnvironment($env)) && ($_t6 instanceof Enum) ? $_t6 != apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown : !_hx_equal($_t6, apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown))) {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			} else {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
			}
		}
		$tmp4 = "Filter \"" . Std::string($this) . "\" has an unsupported compound operator or children count. Filter match is unknown.";
		apptimize_ABTLogger::w($tmp4, _hx_anonymous(array("fileName" => "ABTFilter.hx", "lineNumber" => 463, "className" => "apptimize.filter.ABTCompoundFilter", "methodName" => "filterMatchesEnvironment")));
		return apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown;
	}
	public function getUrlKeys() {
		$children = $this->value;
		$childUrls = Lambda::harray(Lambda::flatMap($children, array(new _hx_lambda(array(), "apptimize_filter_ABTCompoundFilter_0"), 'execute')));
		if($this->callServerURLKey === null) {
			return $childUrls;
		}
		return _hx_deref((new _hx_array(array($this->callServerURLKey))))->concat($childUrls);
	}
	function __toString() { return 'apptimize.filter.ABTCompoundFilter'; }
}
function apptimize_filter_ABTCompoundFilter_0($child) {
	{
		return $child->getUrlKeys();
	}
}
