<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_filter_ABTFilterUtils {
	public function __construct(){}
	static function __meta__() { $args = func_get_args(); return call_user_func_array(self::$__meta__, $args); }
	static $__meta__;
	static function ABTFilterAnd($left, $right) {
		$tmp = null;
		if($left === apptimize_filter_ABTFilterResult::$ABTFilterResultTrue) {
			$tmp = $right === apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown;
		} else {
			$tmp = false;
		}
		if($tmp) {
			return apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown;
		}
		$tmp1 = null;
		if($left === apptimize_filter_ABTFilterResult::$ABTFilterResultTrue) {
			$tmp1 = $right === apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
		} else {
			$tmp1 = false;
		}
		if($tmp1) {
			return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
		}
		$tmp2 = null;
		if($left === apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown) {
			$tmp2 = $right === apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
		} else {
			$tmp2 = false;
		}
		if($tmp2) {
			return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
		}
		return $left;
	}
	static function ABTFilterOr($left, $right) {
		$tmp = null;
		if($left === apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown) {
			$tmp = $right === apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
		} else {
			$tmp = false;
		}
		if($tmp) {
			return apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown;
		}
		$tmp1 = null;
		if($left === apptimize_filter_ABTFilterResult::$ABTFilterResultTrue) {
			$tmp1 = $right === apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
		} else {
			$tmp1 = false;
		}
		if($tmp1) {
			return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
		}
		$tmp2 = null;
		if($left === apptimize_filter_ABTFilterResult::$ABTFilterResultTrue) {
			$tmp2 = $right === apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown;
		} else {
			$tmp2 = false;
		}
		if($tmp2) {
			return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
		}
		return $right;
	}
	static function ABTEvaluateString($left, $operator, $right) {
		$leftString = "";
		$rightString = "";
		$tmp = null;
		if($left !== null) {
			$tmp = $right === null;
		} else {
			$tmp = true;
		}
		if($tmp) {
			apptimize_ABTLogger::w("String comparison attempted with null string. Filter match is unknown.", _hx_anonymous(array("fileName" => "ABTFilter.hx", "lineNumber" => 707, "className" => "apptimize.filter.ABTFilterUtils", "methodName" => "ABTEvaluateString")));
			return apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown;
		}
		if((is_object($_t = Type::getClass($left)) && ($_t instanceof Enum) ? $_t == _hx_qtype("String") : _hx_equal($_t, _hx_qtype("String")))) {
			$leftString = $left;
		}
		if((is_object($_t2 = Type::getClass($right)) && ($_t2 instanceof Enum) ? $_t2 == _hx_qtype("String") : _hx_equal($_t2, _hx_qtype("String")))) {
			$rightString = $right;
		}
		$leftString = strtolower($leftString);
		$rightString = strtolower($rightString);
		if($operator === apptimize_filter_ABTFilterOperator::$ABTFilterOperatorEquals) {
			if($leftString === $rightString) {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			} else {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
			}
		}
		if($operator === apptimize_filter_ABTFilterOperator::$ABTFilterOperatorNotEquals) {
			if($leftString !== $rightString) {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			} else {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
			}
		}
		apptimize_ABTLogger::w("String comparison attempted with an invalid operator. Filter match is unknown.", _hx_anonymous(array("fileName" => "ABTFilter.hx", "lineNumber" => 727, "className" => "apptimize.filter.ABTFilterUtils", "methodName" => "ABTEvaluateString")));
		return apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown;
	}
	static function ABTEvaluateBool($left, $operator, $right) {
		if($operator === apptimize_filter_ABTFilterOperator::$ABTFilterOperatorEquals) {
			if($left === $right) {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			} else {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
			}
		}
		if($operator === apptimize_filter_ABTFilterOperator::$ABTFilterOperatorNotEquals) {
			if($left !== $right) {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			} else {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
			}
		}
		apptimize_ABTLogger::w("Bool comparison attempted with an invalid operator. Filter match is unknown.", _hx_anonymous(array("fileName" => "ABTFilter.hx", "lineNumber" => 737, "className" => "apptimize.filter.ABTFilterUtils", "methodName" => "ABTEvaluateBool")));
		return apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown;
	}
	static function ABTEvaluateNumber($left, $operator, $right) {
		$leftFloat = null;
		$rightFloat = null;
		$tmp = null;
		if($left !== null) {
			$tmp = $right === null;
		} else {
			$tmp = true;
		}
		if($tmp) {
			return apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown;
		}
		if((is_object($_t = Type::getClass($left)) && ($_t instanceof Enum) ? $_t == _hx_qtype("String") : _hx_equal($_t, _hx_qtype("String")))) {
			$leftFloat = Std::parseFloat($left);
		} else {
			$leftFloat = $left;
		}
		if((is_object($_t2 = Type::getClass($right)) && ($_t2 instanceof Enum) ? $_t2 == _hx_qtype("String") : _hx_equal($_t2, _hx_qtype("String")))) {
			$rightFloat = Std::parseFloat($right);
		} else {
			$rightFloat = $right;
		}
		if($operator === apptimize_filter_ABTFilterOperator::$ABTFilterOperatorEquals) {
			if(_hx_equal($leftFloat, $rightFloat)) {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			} else {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
			}
		}
		if($operator === apptimize_filter_ABTFilterOperator::$ABTFilterOperatorNotEquals) {
			if(!_hx_equal($leftFloat, $rightFloat)) {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			} else {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
			}
		}
		if($operator === apptimize_filter_ABTFilterOperator::$ABTFilterOperatorGreaterThan) {
			if($leftFloat > $rightFloat) {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			} else {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
			}
		}
		if($operator === apptimize_filter_ABTFilterOperator::$ABTFilterOperatorGreaterThanOrEqual) {
			if($leftFloat >= $rightFloat) {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			} else {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
			}
		}
		if($operator === apptimize_filter_ABTFilterOperator::$ABTFilterOperatorLessThan) {
			if($leftFloat < $rightFloat) {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			} else {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
			}
		}
		if($operator === apptimize_filter_ABTFilterOperator::$ABTFilterOperatorLessThanOrEqual) {
			if($leftFloat <= $rightFloat) {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			} else {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
			}
		}
		apptimize_ABTLogger::w("Number comparison attempted with an invalid operator. Filter match is unknown.", _hx_anonymous(array("fileName" => "ABTFilter.hx", "lineNumber" => 769, "className" => "apptimize.filter.ABTFilterUtils", "methodName" => "ABTEvaluateNumber")));
		return apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown;
	}
	static function ABTEvaluateVersionString($left, $operator, $right) {
		$tmp = null;
		if($left !== null) {
			$tmp = _hx_equal($left, "");
		} else {
			$tmp = true;
		}
		if($tmp) {
			$left = "0";
		}
		$tmp1 = null;
		if($right !== null) {
			$tmp1 = _hx_equal($right, "");
		} else {
			$tmp1 = true;
		}
		if($tmp1) {
			$right = "0";
		}
		$tmp2 = null;
		if((is_object($_t = Type::getClass($left)) && ($_t instanceof Enum) ? $_t == _hx_qtype("String") : _hx_equal($_t, _hx_qtype("String")))) {
			$tmp2 = (is_object($_t2 = Type::getClass($right)) && ($_t2 instanceof Enum) ? $_t2 != _hx_qtype("String") : !_hx_equal($_t2, _hx_qtype("String")));
		} else {
			$tmp2 = true;
		}
		if($tmp2) {
			apptimize_ABTLogger::w("Unable to compare versions as values are not strings. Filter match is unknown.", _hx_anonymous(array("fileName" => "ABTFilter.hx", "lineNumber" => 787, "className" => "apptimize.filter.ABTFilterUtils", "methodName" => "ABTEvaluateVersionString")));
			return apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown;
		}
		$leftString = $left;
		$rightString = $right;
		$leftComponents = _hx_explode(".", $leftString);
		$rightComponents = _hx_explode(".", $rightString);
		$leftLength = $leftComponents->length;
		if($leftLength < 3) {
			$_g = $leftLength;
			while($_g < 3) {
				$_g = $_g + 1;
				$i = $_g - 1;
				$leftComponents->push("0");
				unset($i);
			}
		}
		$rightLength = $rightComponents->length;
		if($rightLength < 3) {
			$_g1 = $rightLength;
			while($_g1 < 3) {
				$_g1 = $_g1 + 1;
				$i1 = $_g1 - 1;
				$rightComponents->push("0");
				unset($i1);
			}
		}
		$leftString = $leftComponents->join(".");
		$rightString = $rightComponents->join(".");
		$leftVersion = null;
		$rightVersion = null;
		try {
			$leftVersion = thx_semver__Version_Version_Impl_::stringToVersion($leftString);
		}catch(Exception $__hx__e) {
			$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
			$e = $_ex_;
			{
				apptimize_ABTLogger::w("Unable to validate left (current) version: " . _hx_string_or_null($leftString) . ". Filter match is unknown.", _hx_anonymous(array("fileName" => "ABTFilter.hx", "lineNumber" => 827, "className" => "apptimize.filter.ABTFilterUtils", "methodName" => "ABTEvaluateVersionString")));
				return apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown;
			}
		}
		try {
			$rightVersion = thx_semver__Version_Version_Impl_::stringToVersion($rightString);
		}catch(Exception $__hx__e) {
			$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
			$e1 = $_ex_;
			{
				apptimize_ABTLogger::w("Unable to validate right (filter) version: " . _hx_string_or_null($rightString) . ". Filter match is unknown.", _hx_anonymous(array("fileName" => "ABTFilter.hx", "lineNumber" => 833, "className" => "apptimize.filter.ABTFilterUtils", "methodName" => "ABTEvaluateVersionString")));
				return apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown;
			}
		}
		if($operator === apptimize_filter_ABTFilterOperator::$ABTFilterOperatorEquals) {
			if(thx_semver__Version_Version_Impl_::equals($leftVersion, $rightVersion)) {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			} else {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
			}
		}
		if($operator === apptimize_filter_ABTFilterOperator::$ABTFilterOperatorNotEquals) {
			if(!thx_semver__Version_Version_Impl_::equals($leftVersion, $rightVersion)) {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			} else {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
			}
		}
		if($operator === apptimize_filter_ABTFilterOperator::$ABTFilterOperatorGreaterThan) {
			if(thx_semver__Version_Version_Impl_::greaterThan($leftVersion, $rightVersion)) {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			} else {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
			}
		}
		if($operator === apptimize_filter_ABTFilterOperator::$ABTFilterOperatorGreaterThanOrEqual) {
			if(thx_semver__Version_Version_Impl_::greaterThanOrEqual($leftVersion, $rightVersion)) {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			} else {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
			}
		}
		if($operator === apptimize_filter_ABTFilterOperator::$ABTFilterOperatorLessThan) {
			if(thx_semver__Version_Version_Impl_::lessThan($leftVersion, $rightVersion)) {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			} else {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
			}
		}
		if($operator === apptimize_filter_ABTFilterOperator::$ABTFilterOperatorLessThanOrEqual) {
			if(thx_semver__Version_Version_Impl_::lessThanOrEqual($leftVersion, $rightVersion)) {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			} else {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
			}
		}
		apptimize_ABTLogger::w("Version comparison attempted with an invalid operator. Filter match is unknown.", _hx_anonymous(array("fileName" => "ABTFilter.hx", "lineNumber" => 845, "className" => "apptimize.filter.ABTFilterUtils", "methodName" => "ABTEvaluateVersionString")));
		return apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown;
	}
	function __toString() { return 'apptimize.filter.ABTFilterUtils'; }
}
apptimize_filter_ABTFilterUtils::$__meta__ = _hx_anonymous(array("statics" => _hx_anonymous(array("ABTEvaluateString" => _hx_anonymous(array("static" => null)), "ABTEvaluateBool" => _hx_anonymous(array("static" => null)), "ABTEvaluateNumber" => _hx_anonymous(array("static" => null))))));
