<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_filter_ABTFilterableObject {
	public function __construct() {
		if(!php_Boot::$skip_constructor) {
		$this->initialize();
	}}
	public $filters;
	public $filters2;
	public $overridingInclusiveFilters;
	public $matchingFilters;
	public $nonMatchingFilters;
	public function initialize() {
		$this->filters = new _hx_array(array());
		$this->filters2 = new _hx_array(array());
		$this->matchingFilters = new _hx_array(array());
		$this->nonMatchingFilters = new _hx_array(array());
		$this->overridingInclusiveFilters = new _hx_array(array());
	}
	public function performFilterMatchingWithEnvironment($env) {
		$ret = _hx_anonymous(array("result" => apptimize_filter_ABTFilterResult::$ABTFilterResultTrue, "overriding" => false));
		{
			$_g = 0;
			$_g1 = $this->filters;
			while($_g < $_g1->length) {
				$filter = $_g1[$_g];
				$_g = $_g + 1;
				$match = $filter->filterMatchesEnvironment($env);
				$ret->result = apptimize_filter_ABTFilterUtils::ABTFilterAnd($ret->result, $match);
				unset($match,$filter);
			}
		}
		{
			$_g2 = 0;
			$_g11 = $this->overridingInclusiveFilters;
			while($_g2 < $_g11->length) {
				$filter1 = $_g11[$_g2];
				$_g2 = $_g2 + 1;
				$match1 = $filter1->filterMatchesEnvironment($env);
				if($match1 === apptimize_filter_ABTFilterResult::$ABTFilterResultTrue) {
					$ret->result = apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
					$ret->overriding = true;
				}
				unset($match1,$filter1);
			}
		}
		return $ret;
	}
	public function computeNewOverrideState($wasOverrideOnly, $matchResult) {
		if($wasOverrideOnly) {
			if($matchResult->overriding) {
				return false;
			}
		} else {
			if((is_object($_t = $matchResult->result) && ($_t instanceof Enum) ? $_t != apptimize_filter_ABTFilterResult::$ABTFilterResultTrue : !_hx_equal($_t, apptimize_filter_ABTFilterResult::$ABTFilterResultTrue))) {
				return true;
			}
		}
		return $wasOverrideOnly;
	}
	public function fromJSON($json) {
		$this->filters = $this->jsonToFilterArray(_hx_field($json, "filters"));
		$this->filters2 = $this->jsonToFilterArray(_hx_field($json, "filters2"));
		$this->overridingInclusiveFilters = $this->jsonToFilterArray(_hx_field($json, "overridingInclusiveFilters"));
		if($this->filters2->length > 0) {
			$this->filters = $this->filters->concat($this->filters2);
		}
	}
	public function jsonToFilterArray($input) {
		$filterArray = null;
		if($input === null) {
			$filterArray = new _hx_array(array());
		} else {
			$filterArray = $input;
		}
		return $filterArray->map(array(new _hx_lambda(array(), "apptimize_filter_ABTFilterableObject_0"), 'execute'));
	}
	public function getUrlKeys() {
		$tmp = $this->getLocalUrlKeys();
		return $tmp->concat($this->getUrlKeysFrom($this->getUrlKeyProviders()));
	}
	public function getUrlKeyProviders() {
		return (new _hx_array(array()));
	}
	public function getUrlKeysFrom($items) {
		return Lambda::harray(Lambda::flatMap($items, array(new _hx_lambda(array(), "apptimize_filter_ABTFilterableObject_1"), 'execute')));
	}
	public function getLocalUrlKeys() {
		$tmp = $this->getUrlKeysFrom($this->filters);
		return $tmp->concat($this->getUrlKeysFrom($this->overridingInclusiveFilters));
	}
	public function asUrlProviders($items) {
		return $items->map(array(new _hx_lambda(array(), "apptimize_filter_ABTFilterableObject_2"), 'execute'));
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	function __toString() { return 'apptimize.filter.ABTFilterableObject'; }
}
function apptimize_filter_ABTFilterableObject_0($filter) {
	{
		return apptimize_filter_ABTFilter::filterFromJSON($filter);
	}
}
function apptimize_filter_ABTFilterableObject_1($item) {
	{
		return $item->getUrlKeys();
	}
}
function apptimize_filter_ABTFilterableObject_2($item) {
	{
		return $item;
	}
}
