<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_filter_ABTListFilter extends apptimize_filter_ABTFilter {
	public function __construct() { if(!php_Boot::$skip_constructor) {
		parent::__construct();
	}}
	public function fromJSON($json) {
		parent::fromJSON($json);
		$this->value = _hx_field($json, "value");
	}
	public function filterMatchesEnvironment($env) {
		if(!$this->hasSupportedProperty($env)) {
			return apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown;
		}
		$children = $this->value;
		$currentValue = $this->currentDeviceValue($env);
		if($currentValue === null) {
			$tmp = "Filter \"" . Std::string($this) . "\" is attempting to match against a null device property.";
			apptimize_ABTLogger::w($tmp, _hx_anonymous(array("fileName" => "ABTFilter.hx", "lineNumber" => 502, "className" => "apptimize.filter.ABTListFilter", "methodName" => "filterMatchesEnvironment")));
			if($children->indexOf($currentValue, null) > -1) {
				if((is_object($_t = $this->filterOperator) && ($_t instanceof Enum) ? $_t == apptimize_filter_ABTFilterOperator::$ABTFilterOperatorInList : _hx_equal($_t, apptimize_filter_ABTFilterOperator::$ABTFilterOperatorInList))) {
					return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
				} else {
					return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
				}
			} else {
				if((is_object($_t = $this->filterOperator) && ($_t instanceof Enum) ? $_t == apptimize_filter_ABTFilterOperator::$ABTFilterOperatorInList : _hx_equal($_t, apptimize_filter_ABTFilterOperator::$ABTFilterOperatorInList))) {
					return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
				} else {
					return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
				}
			}
		}
		$inList = false;
		{
			$_g = 0;
			while($_g < $children->length) {
				$childValue = $children[$_g];
				$_g = $_g + 1;
				if((is_object($_t = Type::getClass($currentValue)) && ($_t instanceof Enum) ? $_t == _hx_qtype("String") : _hx_equal($_t, _hx_qtype("String")))) {
					if(!$inList) {
						$inList = (is_object($_t2 = apptimize_filter_ABTFilterUtils::ABTEvaluateString($currentValue, apptimize_filter_ABTFilterOperator::$ABTFilterOperatorEquals, $childValue)) && ($_t2 instanceof Enum) ? $_t2 == apptimize_filter_ABTFilterResult::$ABTFilterResultTrue : _hx_equal($_t2, apptimize_filter_ABTFilterResult::$ABTFilterResultTrue));
						unset($_t2);
					} else {
						$inList = true;
					}
				} else {
					if(!$inList) {
						$inList = (is_object($_t2 = apptimize_filter_ABTFilterUtils::ABTEvaluateNumber($currentValue, apptimize_filter_ABTFilterOperator::$ABTFilterOperatorEquals, $childValue)) && ($_t2 instanceof Enum) ? $_t2 == apptimize_filter_ABTFilterResult::$ABTFilterResultTrue : _hx_equal($_t2, apptimize_filter_ABTFilterResult::$ABTFilterResultTrue));
						unset($_t2);
					} else {
						$inList = true;
					}
				}
				unset($childValue,$_t);
			}
		}
		if((is_object($_t = $this->filterOperator) && ($_t instanceof Enum) ? $_t == apptimize_filter_ABTFilterOperator::$ABTFilterOperatorNotInList : _hx_equal($_t, apptimize_filter_ABTFilterOperator::$ABTFilterOperatorNotInList))) {
			if(!$inList) {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			} else {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
			}
		}
		if($inList) {
			return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
		} else {
			return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
		}
	}
	function __toString() { return 'apptimize.filter.ABTListFilter'; }
}
