<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_filter_ABTNamedFilter extends apptimize_filter_ABTFilter {
	public function __construct() {
		if(!php_Boot::$skip_constructor) {
		parent::__construct();
	}}
	public $namedFilter;
	public function fromJSON($json) {
		parent::fromJSON($json);
		$this->namedFilter = Reflect::field($json, apptimize_filter_ABTFilter::$kABTFilterKeyNamedFilter);
	}
	public function filterMatchesEnvironment($env) {
		apptimize_ABTLogger::e("Named filter not implemented. Filter match is unknown.", _hx_anonymous(array("fileName" => "ABTFilter.hx", "lineNumber" => 668, "className" => "apptimize.filter.ABTNamedFilter", "methodName" => "filterMatchesEnvironment")));
		return apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown;
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	function __toString() { return 'apptimize.filter.ABTNamedFilter'; }
}
