<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_filter_ABTPropertylessFilter extends apptimize_filter_ABTFilter {
	public function __construct() { if(!php_Boot::$skip_constructor) {
		parent::__construct();
	}}
	public function fromJSON($json) {
		parent::fromJSON($json);
		$this->value = Reflect::field($json, apptimize_filter_ABTFilter::$kABTFilterKeyValue);
	}
	public function filterMatchesEnvironment($env) {
		$filterValue = $this->value;
		$tmp = null;
		if($filterValue !== null) {
			$tmp = (is_object($_t = Type::getClass($filterValue)) && ($_t instanceof Enum) ? $_t != _hx_qtype("String") : !_hx_equal($_t, _hx_qtype("String")));
		} else {
			$tmp = true;
		}
		if($tmp) {
			apptimize_ABTLogger::w("Property-less filter requires a string value. Filter match is unknown.", _hx_anonymous(array("fileName" => "ABTFilter.hx", "lineNumber" => 620, "className" => "apptimize.filter.ABTPropertylessFilter", "methodName" => "filterMatchesEnvironment")));
			return apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown;
		}
		$filterString = $filterValue;
		if((is_object($_t = $this->filterOperator) && ($_t instanceof Enum) ? $_t == apptimize_filter_ABTFilterOperator::$ABTFilterOperatorPropertyIsNull : _hx_equal($_t, apptimize_filter_ABTFilterOperator::$ABTFilterOperatorPropertyIsNull))) {
			$currentValue = $env->valueForProperty($filterString, apptimize_filter_ABTFilterPropertySource::$ABTFilterPropertySourceDevice);
			if($currentValue === null) {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			} else {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
			}
		}
		if((is_object($_t2 = $this->filterOperator) && ($_t2 instanceof Enum) ? $_t2 == apptimize_filter_ABTFilterOperator::$ABTFilterOperatorPropertyIsNotNull : _hx_equal($_t2, apptimize_filter_ABTFilterOperator::$ABTFilterOperatorPropertyIsNotNull))) {
			$currentValue1 = $env->valueForProperty($filterString, apptimize_filter_ABTFilterPropertySource::$ABTFilterPropertySourceDevice);
			if($currentValue1 !== null) {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			} else {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
			}
		}
		if((is_object($_t3 = $this->filterOperator) && ($_t3 instanceof Enum) ? $_t3 == apptimize_filter_ABTFilterOperator::$ABTFilterOperatorPropertyIsRecognized : _hx_equal($_t3, apptimize_filter_ABTFilterOperator::$ABTFilterOperatorPropertyIsRecognized))) {
			if($this->isSupportedProperty($env, $filterString, apptimize_filter_ABTFilterPropertySource::$ABTFilterPropertySourceDevice) === true) {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			} else {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
			}
		}
		if((is_object($_t4 = $this->filterOperator) && ($_t4 instanceof Enum) ? $_t4 == apptimize_filter_ABTFilterOperator::$ABTFilterOperatorPropertyIsNotRecognized : _hx_equal($_t4, apptimize_filter_ABTFilterOperator::$ABTFilterOperatorPropertyIsNotRecognized))) {
			if($this->isSupportedProperty($env, $filterString, apptimize_filter_ABTFilterPropertySource::$ABTFilterPropertySourceDevice) === false) {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			} else {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
			}
		}
		if((is_object($_t5 = $this->filterOperator) && ($_t5 instanceof Enum) ? $_t5 == apptimize_filter_ABTFilterOperator::$ABTFilterOperatorOperatorIsRecognized : _hx_equal($_t5, apptimize_filter_ABTFilterOperator::$ABTFilterOperatorOperatorIsRecognized))) {
			if($this->isSupportedOperator($filterString) === true) {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			} else {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
			}
		}
		if((is_object($_t6 = $this->filterOperator) && ($_t6 instanceof Enum) ? $_t6 == apptimize_filter_ABTFilterOperator::$ABTFilterOperatorOperatorIsNotRecognized : _hx_equal($_t6, apptimize_filter_ABTFilterOperator::$ABTFilterOperatorOperatorIsNotRecognized))) {
			if($this->isSupportedOperator($filterString) === false) {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultTrue;
			} else {
				return apptimize_filter_ABTFilterResult::$ABTFilterResultFalse;
			}
		}
		apptimize_ABTLogger::w("Property-less filter attempted with an invalid operator. Filter match is unknown.", _hx_anonymous(array("fileName" => "ABTFilter.hx", "lineNumber" => 652, "className" => "apptimize.filter.ABTPropertylessFilter", "methodName" => "filterMatchesEnvironment")));
		return apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown;
	}
	function __toString() { return 'apptimize.filter.ABTPropertylessFilter'; }
}
