<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_http_ABTHttpRequest {
	public function __construct(){}
	static function getRequestInterface() {
		return apptimize_http_ABTHttpRequest::getRealRequestInterface();
	}
	static function getRealRequestInterface() {
		return new apptimize_http_ABTHttpRequestCurl();
	}
	static function get($url, $requestHeaders, $successCallback, $failureCallback) {
		$requestInterface = apptimize_http_ABTHttpRequest::getRequestInterface();
		$requestInterface->get($url, $requestHeaders, $successCallback, $failureCallback);
	}
	static function post($url, $data, $appKey, $successCallback, $failureCallback) {
		$requestInterface = apptimize_http_ABTHttpRequest::getRequestInterface();
		$requestInterface->post($url, $data, $appKey, $successCallback, $failureCallback);
	}
	function __toString() { return 'apptimize.http.ABTHttpRequest'; }
}
