<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_http_ABTHttpRequestCurl implements apptimize_http_ABTHttpRequestInterface{
	public function __construct() {}
	public function get($url, $requestHeaders, $successCallback, $failureCallback) {
		$headerArray = new _hx_array(array());
		if($requestHeaders !== null) {
			$key = $requestHeaders->keys();
			while($key->hasNext()) {
				$key1 = $key->next();
				$headerArray->push(_hx_string_or_null($key1) . ": " . _hx_string_or_null($requestHeaders->get($key1)));
				unset($key1);
			}
		}
		$httpResponse = $this->request("CURLOPT_HTTPGET", $url, null, $headerArray);
		if($httpResponse->isSuccess()) {
			call_user_func_array($successCallback, array($httpResponse));
		} else {
			call_user_func_array($failureCallback, array($httpResponse));
		}
	}
	public function post($url, $data, $appKey, $successCallback, $failureCallback) {
		$headerArray = new _hx_array(array());
		$headerArray->push("X-App-Key: " . _hx_string_or_null($appKey));
		$headerArray->push("Content-Type: application/json; charset=UTF-8");
		$httpResponse = $this->request("CURLOPT_POST", $url, $data, $headerArray);
		if($httpResponse->isSuccess()) {
			call_user_func_array($successCallback, array($httpResponse));
		} else {
			call_user_func_array($failureCallback, array($httpResponse));
		}
	}
	public function request($method, $url, $data = null, $headers = null) {
		$httpResponse = new apptimize_http_ABTHttpResponse();
		$curl = curl_init(null);
		$tmp = null;
		if($data !== null) {
			$tmp = $method === "CURLOPT_HTTPGET";
		} else {
			$tmp = false;
		}
		if($tmp) {
			$url1 = null;
			if(_hx_index_of($url, "?", null) >= 0) {
				$url1 = "&";
			} else {
				$url2 = Reflect::fields($data);
				$url1 = "?" . _hx_string_or_null(Lambda::map($url2, array(new _hx_lambda(array(&$data), "apptimize_http_ABTHttpRequestCurl_0"), 'execute'))->join("&"));
			}
			$url = _hx_string_or_null($url) . _hx_string_or_null($url1);
		}
		{
			$value = $url;
			if(Std::is($value, _hx_qtype("Array"))) {
				$value = php_Lib::toPhpArray($value);
			}
			curl_setopt($curl, CURLOPT_URL, $value);
		}
		$returnHeaders = new haxe_ds_StringMap();
		$headerMethod = array(new _hx_lambda(array(&$returnHeaders), "apptimize_http_ABTHttpRequestCurl_1"), 'execute');
		{
			$value1 = $headerMethod;
			if(Std::is($value1, _hx_qtype("Array"))) {
				$value1 = php_Lib::toPhpArray($value1);
			}
			curl_setopt($curl, CURLOPT_HEADERFUNCTION, $value1);
		}
		{
			$value2 = true;
			if(Std::is($value2, _hx_qtype("Array"))) {
				$value2 = php_Lib::toPhpArray($value2);
			}
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, $value2);
		}
		$tmp1 = null;
		if($data !== null) {
			$tmp1 = $method === "CURLOPT_POST";
		} else {
			$tmp1 = false;
		}
		if($tmp1) {
			{
				$value3 = true;
				if(Std::is($value3, _hx_qtype("Array"))) {
					$value3 = php_Lib::toPhpArray($value3);
				}
				curl_setopt($curl, CURLOPT_POST, $value3);
			}
			{
				$value4 = _hx_string_call($data, "toString", array());
				if(Std::is($value4, _hx_qtype("Array"))) {
					$value4 = php_Lib::toPhpArray($value4);
				}
				curl_setopt($curl, CURLOPT_POSTFIELDS, $value4);
			}
		}
		if($headers !== null) {
			$value5 = $headers;
			if(Std::is($value5, _hx_qtype("Array"))) {
				$value5 = php_Lib::toPhpArray($value5);
			}
			curl_setopt($curl, CURLOPT_HTTPHEADER, $value5);
		}
		$val = curl_exec($curl);
		$response = null;
		if(!$val) {
			$response = null;
		} else {
			$response = $val;
		}
		$info = php_Lib::hashOfAssociativeArray(curl_getinfo($curl));
		$bytes = haxe_io_Bytes::ofString($response);
		$httpResponse->bytes = $bytes->b;
		$httpResponse->etag = $returnHeaders->get("etag");
		$httpResponse->responseCode = $info->get("http_code");
		curl_close($curl);
		return $httpResponse;
	}
	function __toString() { return 'apptimize.http.ABTHttpRequestCurl'; }
}
function apptimize_http_ABTHttpRequestCurl_0(&$data, $fieldName) {
	{
		$fieldValue = Reflect::field($data, $fieldName);
		$url3 = _hx_string_or_null(rawurlencode($fieldName)) . "=";
		return _hx_string_or_null($url3) . _hx_string_or_null(rawurlencode($fieldValue));
	}
}
function apptimize_http_ABTHttpRequestCurl_1(&$returnHeaders, $resource, $headerOpt) {
	{
		$split = _hx_explode(":", $headerOpt);
		$headerMethod1 = null;
		if($split !== null) {
			$headerMethod1 = $split->length === 2;
		} else {
			$headerMethod1 = false;
		}
		if($headerMethod1) {
			$headerMethod2 = strtolower(trim($split[0]));
			$headerMethod3 = trim($split[1]);
			$returnHeaders->set($headerMethod2, $headerMethod3);
		}
		return strlen($headerOpt);
	}
}
