<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_models_ABTHotfixVariant extends apptimize_models_ABTVariant {
	public function __construct($variant) {
		if(!php_Boot::$skip_constructor) {
		parent::__construct($variant);
	}}
	public $hotfixName;
	public function fromJSON($obj) {
		parent::fromJSON($obj);
		$variant = $obj;
		$this->hotfixName = $variant->hotfixName;
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	function __toString() { return 'apptimize.models.ABTHotfixVariant'; }
}
