<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_models_results_ABTResultEntryEvent extends apptimize_models_results_ABTResultEntry {
	public function __construct($env, $name, $source, $attributes) {
		if(!php_Boot::$skip_constructor) {
		$this->_type = "ee";
		parent::__construct($env);
		$this->_name = $name;
		$this->_source = $source;
		$this->_attributes = $attributes;
	}}
	public $_type;
	public $_name;
	public $_source;
	public $_attributes;
	public function JSONRepresentation() {
		$jsonDict = parent::JSONRepresentation();
		{
			$v = $this->_type;
			$jsonDict->set("ty", $v);
		}
		{
			$v1 = $this->_name;
			$jsonDict->set("n", $v1);
		}
		{
			$v2 = $this->_source;
			$jsonDict->set("s", $v2);
		}
		{
			$v3 = $this->_attributes;
			$jsonDict->set("a", $v3);
		}
		return $jsonDict;
	}
	public function hxSerialize($s) {
		parent::hxSerialize($s);
		$s->serialize($this->_type);
		$s->serialize($this->_name);
		$s->serialize($this->_source);
		$s->serialize($this->_attributes);
	}
	public function hxUnserialize($u) {
		parent::hxUnserialize($u);
		$this->_type = $u->unserialize();
		$this->_name = $u->unserialize();
		$this->_source = $u->unserialize();
		$this->_attributes = $u->unserialize();
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	function __toString() { return 'apptimize.models.results.ABTResultEntryEvent'; }
}
