<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_models_results_ABTResultEntryMetadataProcessed extends apptimize_models_results_ABTResultEntry {
	public function __construct($env, $sequence, $enrolledVariantsCyclesPhases) {
		if(!php_Boot::$skip_constructor) {
		$this->_type = "md";
		parent::__construct($env);
		$this->_metadataSequenceNumber = $sequence;
		$this->_enrolledVariantsCyclesPhases = $enrolledVariantsCyclesPhases;
		$this->_enrolledVariantIDs = new _hx_array(array());
		{
			$_g = 0;
			$_g1 = $this->_enrolledVariantsCyclesPhases;
			while($_g < $_g1->length) {
				$variantCyclePhase = $_g1[$_g];
				$_g = $_g + 1;
				$this->_enrolledVariantIDs->push($variantCyclePhase->v);
				unset($variantCyclePhase);
			}
		}
	}}
	public $_type;
	public $_metadataSequenceNumber;
	public $_enrolledVariantsCyclesPhases;
	public $_enrolledVariantIDs;
	public function JSONRepresentation() {
		$jsonDict = parent::JSONRepresentation();
		if($this->_enrolledVariantsCyclesPhases->length > 0) {
			$v = $this->_enrolledVariantsCyclesPhases;
			$jsonDict->set("vp", $v);
		}
		{
			$v1 = $this->_enrolledVariantIDs;
			$jsonDict->set("v", $v1);
		}
		{
			$v2 = $this->_metadataSequenceNumber;
			$jsonDict->set("s", $v2);
		}
		{
			$v3 = $this->_type;
			$jsonDict->set("ty", $v3);
		}
		return $jsonDict;
	}
	public function hxSerialize($s) {
		parent::hxSerialize($s);
		$s->serialize($this->_type);
		$s->serialize($this->_metadataSequenceNumber);
		$s->serialize($this->_enrolledVariantIDs);
		$s->serialize($this->_enrolledVariantsCyclesPhases);
	}
	public function hxUnserialize($u) {
		parent::hxUnserialize($u);
		$this->_type = $u->unserialize();
		$this->_metadataSequenceNumber = $u->unserialize();
		$this->_enrolledVariantIDs = $u->unserialize();
		$this->_enrolledVariantsCyclesPhases = $u->unserialize();
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	function __toString() { return 'apptimize.models.results.ABTResultEntryMetadataProcessed'; }
}
