<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_models_results_ABTResultEntryUserStart extends apptimize_models_results_ABTResultEntry {
	public function __construct($env, $previousUserID) {
		if(!php_Boot::$skip_constructor) {
		$this->_type = "us";
		parent::__construct($env);
		$this->_previousUserID = $previousUserID;
	}}
	public $_type;
	public $_previousUserID;
	public function JSONRepresentation() {
		$jsonDict = parent::JSONRepresentation();
		{
			$v = $this->_type;
			$jsonDict->set("ty", $v);
		}
		{
			$v1 = $this->_previousUserID;
			$jsonDict->set("p", $v1);
		}
		return $jsonDict;
	}
	public function hxSerialize($s) {
		parent::hxSerialize($s);
		$s->serialize($this->_type);
		$s->serialize($this->_previousUserID);
	}
	public function hxUnserialize($u) {
		parent::hxUnserialize($u);
		$this->_type = $u->unserialize();
		$this->_previousUserID = $u->unserialize();
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	function __toString() { return 'apptimize.models.results.ABTResultEntryUserStart'; }
}
