<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_support_initialize_ABTPlatformInitialize {
	public function __construct(){}
	static $_isThreadingEnabled;
	static function initialize() {
		$tmp = apptimize_support_persistence_ABTPersistence::$kApptimizeVersionKey;
		apptimize_support_persistence_ABTPersistence::saveString($tmp, apptimize_Apptimize::getApptimizeSDKVersion(), null, null);
		apptimize_support_initialize_ABTPlatformInitialize::$_isThreadingEnabled = apptimize_support_properties_ABTConfigProperties::sharedInstance()->valueForProperty(apptimize_support_properties_ABTConfigProperties::$THREADING_ENABLED_KEY);
		apptimize_support_initialize_ABTPlatformInitialize::hookShutdown(apptimize_support_initialize_ABTPlatformInitialize::$_isThreadingEnabled);
	}
	static function hookShutdown($isThreaded) {
		if(!apptimize_support_properties_ABTConfigProperties::sharedInstance()->valueForProperty(apptimize_support_properties_ABTConfigProperties::$AUTOMATIC_SHUTDOWN_HOOK)) {
			apptimize_ABTLogger::v("Process exits will not be handled to persist Apptimize library state across server restarts.", _hx_anonymous(array("fileName" => "ABTPlatformInitialize.hx", "lineNumber" => 119, "className" => "apptimize.support.initialize.ABTPlatformInitialize", "methodName" => "hookShutdown")));
			return;
		}
		apptimize_ABTLogger::v("This platform does not support handling a shutdown signal to preserve Apptimize library state.\x0A                     Please ensure Apptimize.shutdown() is called when you are shutting down your server.", _hx_anonymous(array("fileName" => "ABTPlatformInitialize.hx", "lineNumber" => 136, "className" => "apptimize.support.initialize.ABTPlatformInitialize", "methodName" => "hookShutdown")));
	}
	static function shutdownPlatform() {
		apptimize_api_ABTMetadataPoller::stopPolling();
	}
	function __toString() { return 'apptimize.support.initialize.ABTPlatformInitialize'; }
}
