<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_support_persistence_ABTPIDiskStorage extends apptimize_support_persistence_ABTPersistentInterface {
	public function __construct() {
		if(!php_Boot::$skip_constructor) {
		$this->_extension = ".data";
		$this->_localStoragePath = "data/apptimize/";
		$this->_localStoragePath = apptimize_support_properties_ABTConfigProperties::sharedInstance()->valueForProperty(apptimize_support_properties_ABTConfigProperties::$LOCAL_DISK_STORAGE_PATH_KEY);
		$path = $this->_localStoragePath;
		if(!file_exists($path)) {
			$path1 = haxe_io_Path::addTrailingSlash($this->_localStoragePath);
			$_p = null;
			$parts = (new _hx_array(array()));
			while(true) {
				$_p = haxe_io_Path::directory($path1);
				if($path1 === $_p) {
					break;
				}
				$parts->unshift($path1);
				$path1 = $_p;
			}
			{
				$_g = 0;
				while($_g < $parts->length) {
					$part = $parts[$_g];
					$_g = $_g + 1;
					$tmp = null;
					if(_hx_char_code_at($part, strlen($part) - 1) !== 58) {
						$tmp = !file_exists($part);
					} else {
						$tmp = false;
					}
					if($tmp) {
						@mkdir($part, 493);
					}
					unset($tmp,$part);
				}
			}
		}
		$this->_keys = new _hx_array(array());
	}}
	public $_localStoragePath;
	public $_extension;
	public $_keys;
	public function _dataFromDisk($path, $localPath = null) {
		if($localPath === null) {
			$localPath = "";
		}
		$filePath = _hx_string_or_null($localPath) . _hx_string_or_null($path) . _hx_string_or_null($this->_extension);
		if(file_exists($filePath)) {
			$content = sys_io_File::getContent($filePath);
			return $content;
		} else {
			apptimize_ABTLogger::v("File not found: " . _hx_string_or_null($filePath) . ". Unable to load data from disk.", _hx_anonymous(array("fileName" => "ABTPIDiskStorage.hx", "lineNumber" => 30, "className" => "apptimize.support.persistence.ABTPIDiskStorage", "methodName" => "_dataFromDisk")));
		}
		return null;
	}
	public function _deleteFile($key, $localPath = null) {
		if($localPath === null) {
			$localPath = "";
		}
		$path = _hx_string_or_null($localPath) . _hx_string_or_null($key) . _hx_string_or_null($this->_extension);
		if(file_exists($path)) {
			$path1 = _hx_string_or_null($localPath) . _hx_string_or_null($key) . _hx_string_or_null($this->_extension);
			unlink($path1);
		}
	}
	public function save($key, $value, $latency = null, $compress = null) {
		if($compress === null) {
			$compress = false;
		}
		if($latency === null) {
			$latency = 0;
		}
		$filePath = _hx_string_or_null($this->_localStoragePath) . _hx_string_or_null($key) . _hx_string_or_null($this->_extension);
		if($value !== null) {
			sys_io_File::saveContent($filePath, $value);
			$this->_keys->push($key);
		} else {
			$this->_deleteFile($key, $this->_localStoragePath);
			$this->_keys->remove($key);
		}
	}
	public function load($key, $latency = null, $callback = null) {
		if($latency === null) {
			$latency = 0;
		}
		$result = $this->_dataFromDisk($key, $this->_localStoragePath);
		if($callback !== null) {
			call_user_func_array($callback, array($key, $result));
		}
		return $result;
	}
	public function clear($latency = null) {
		if($latency === null) {
			$latency = 2;
		}
		{
			$_g = 0;
			$_g1 = $this->_keys;
			while($_g < $_g1->length) {
				$key = $_g1[$_g];
				$_g = $_g + 1;
				$this->_deleteFile($key, $this->_localStoragePath);
				unset($key);
			}
		}
		$this->_keys = new _hx_array(array());
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	function __toString() { return 'apptimize.support.persistence.ABTPIDiskStorage'; }
}
