<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_support_properties_ABTProperties {
	public function __construct() {
		if(!php_Boot::$skip_constructor) {
		$this->PROPERTYLOCK = apptimize_util_ABTDataLock::getNewLock("property_lock");
		$this->availableProperties = new haxe_ds_StringMap();
		$this->PROPERTYLOCK->acquire();
		try {
			$this->availableProperties = new haxe_ds_StringMap();
			$this->setPropertyDefaults();
		}catch(Exception $__hx__e) {
			$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
			$e = $_ex_;
			{
				$this->PROPERTYLOCK->release();
				throw new HException($e);
			}
		}
		$this->PROPERTYLOCK->release();
	}}
	public $availableProperties;
	public $PROPERTYLOCK;
	public function setPropertyDefaults() {
	}
	public function isPropertyAvailable($propertyName) {
		$property = null;
		{
			$this->PROPERTYLOCK->acquire();
			try {
				$property = $this->availableProperties->get($propertyName);
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				$e = $_ex_;
				{
					$this->PROPERTYLOCK->release();
					throw new HException($e);
				}
			}
			$this->PROPERTYLOCK->release();
		}
		return $property !== null;
	}
	public function valueForProperty($propertyName) {
		$property = null;
		{
			$this->PROPERTYLOCK->acquire();
			try {
				$property = $this->availableProperties->get($propertyName);
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				$e = $_ex_;
				{
					$this->PROPERTYLOCK->release();
					throw new HException($e);
				}
			}
			$this->PROPERTYLOCK->release();
		}
		return $property;
	}
	public function setProperty($key, $value) {
		$this->PROPERTYLOCK->acquire();
		try {
			$this->availableProperties->set($key, $value);
		}catch(Exception $__hx__e) {
			$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
			$e = $_ex_;
			{
				$this->PROPERTYLOCK->release();
				throw new HException($e);
			}
		}
		$this->PROPERTYLOCK->release();
	}
	public function setProperties($stringMap) {
		$key = $stringMap->keys();
		while($key->hasNext()) {
			$key1 = $key->next();
			$this->setProperty($key1, $stringMap->get($key1));
			unset($key1);
		}
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	function __toString() { return 'apptimize.support.properties.ABTProperties'; }
}
