<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_util_ABTUtilDictionary {
	public function __construct(){}
	static function dynamicToNativeDictionary($dynamicMap) {
		return php_Lib::associativeArrayOfHash(apptimize_util_ABTUtilDictionary::dynamicMapToStringMap($dynamicMap));
	}
	static function nativeObjectToStringMap($nativeMap) {
		if((is_object($_t = Type::typeof($nativeMap)) && ($_t instanceof Enum) ? $_t == ValueType::$TObject : _hx_equal($_t, ValueType::$TObject))) {
			return apptimize_util_ABTUtilDictionary::dynamicObjectToStringMap($nativeMap);
		}
		if((is_object($_t2 = Type::getClass($nativeMap)) && ($_t2 instanceof Enum) ? $_t2 == _hx_qtype("haxe.ds.StringMap") : _hx_equal($_t2, _hx_qtype("haxe.ds.StringMap")))) {
			return $nativeMap;
		}
		$_g = Type::typeof($nativeMap);
		if($_g->index === 6) {
			if((is_object($_t3 = _hx_deref($_g)->params[0]) && ($_t3 instanceof Enum) ? $_t3 == _hx_qtype("Array") : _hx_equal($_t3, _hx_qtype("Array")))) {
				return apptimize_util_ABTUtilDictionary::nativeArrayToStringMap($nativeMap);
			} else {
				return new haxe_ds_StringMap();
			}
		} else {
			return new haxe_ds_StringMap();
		}
	}
	static function nativeArrayToStringMap($nativeMap) {
		return php_Lib::hashOfAssociativeArray($nativeMap);
	}
	static function dynamicObjectToStringMap($object) {
		$map = new haxe_ds_StringMap();
		$fields = Reflect::fields($object);
		{
			$_g = 0;
			while($_g < $fields->length) {
				$field = $fields[$_g];
				$_g = $_g + 1;
				$map->set($field, Reflect::getProperty($object, $field));
				unset($field);
			}
		}
		return $map;
	}
	static function dynamicMapToStringMap($map) {
		$stringMap = new haxe_ds_StringMap();
		$dict = $map;
		{
			$_g = 0;
			$_g1 = Reflect::fields($dict);
			while($_g < $_g1->length) {
				$key = $_g1[$_g];
				$_g = $_g + 1;
				$stringMap->set($key, Reflect::field($dict, $key));
				unset($key);
			}
		}
		return $stringMap;
	}
	static function filterNullValues($map) {
		$result = new haxe_ds_StringMap();
		{
			$key = $map->keys();
			while($key->hasNext()) {
				$key1 = $key->next();
				$value = $map->get($key1);
				if($value !== null) {
					$result->set($key1, $value);
				}
				unset($value,$key1);
			}
		}
		return $result;
	}
	function __toString() { return 'apptimize.util.ABTUtilDictionary'; }
}
