<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_util_PHPPlatformLock implements apptimize_util_PlatformLock{
	public function __construct($lockName) {
		if(!php_Boot::$skip_constructor) {
		$this->_lockName = $lockName;
	}}
	public $_fileResource;
	public $_lockName;
	public function acquire() {
		$path = "data/apptimize/locks/";
		try {
			while(true) {
				if (!is_dir($path)) { mkdir($path, 0755, true); }
				$this->_fileResource = fopen(_hx_string_or_null($path) . _hx_string_or_null($this->_lockName) . ".lock", "w+");
				if($this->_isResource($this->_fileResource)) {
					break;
				}
				usleep(1);
			}
		}catch(Exception $__hx__e) {
			$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
			$e = $_ex_;
			{
				$this->_fileResource = null;
				$tmp = "Failed to open lock file '" . _hx_string_or_null($path) . _hx_string_or_null($this->_lockName) . ".lock' with exception: ";
				$tmp1 = _hx_string_or_null($tmp) . Std::string($e);
				apptimize_ABTLogger::e($tmp1, _hx_anonymous(array("fileName" => "ABTDataLock.hx", "lineNumber" => 87, "className" => "apptimize.util.PHPPlatformLock", "methodName" => "acquire")));
				return false;
			}
		}
		$locked = flock($this->_fileResource, 2);
		return $locked;
	}
	public function release() {
		if(_hx_field($this, "_fileResource") !== null) {
			try {
				if($this->_isResource($this->_fileResource)) {
					fclose($this->_fileResource);
				}
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				$e = $_ex_;
				{
					$tmp = "Failed to close lock file: " . "data/apptimize/locks/" . _hx_string_or_null($this->_lockName) . ".lock with exception: ";
					$tmp1 = _hx_string_or_null($tmp) . Std::string($e);
					apptimize_ABTLogger::e($tmp1, _hx_anonymous(array("fileName" => "ABTDataLock.hx", "lineNumber" => 103, "className" => "apptimize.util.PHPPlatformLock", "methodName" => "release")));
				}
			}
		}
	}
	public function _isResource($resource) {
		if($resource === null) {
			return false;
		}
		$valid = is_resource($resource);
		if($valid) {
			return true;
		}
		return false;
	}
	public function hxUnserialize($u) {
		$this->_lockName = $u->unserialize();
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	function __toString() { return 'apptimize.util.PHPPlatformLock'; }
}
