<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class hx_concurrent_atomic__AtomicInt_AtomicIntImpl {
	public function __construct($initialValue = null) {
		if(!php_Boot::$skip_constructor) {
		if($initialValue === null) {
			$initialValue = 0;
		}
		$this->lock = new hx_concurrent_lock_RLock();
		$this->_value = $initialValue;
	}}
	public $lock;
	public $_value;
	public function get_value() {
		$this->lock->acquire();
		$result = $this->_value;
		$this->lock->release();
		return $result;
	}
	public function set_value($val) {
		$this->lock->acquire();
		$this->_value = $val;
		$this->lock->release();
		return $val;
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	static $__properties__ = array("set_value" => "set_value","get_value" => "get_value");
	function __toString() { return 'hx.concurrent.atomic._AtomicInt.AtomicIntImpl'; }
}
