<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class thx_semver__Version_Version_Impl_ {
	public function __construct(){}
	static $VERSION;
	static function stringToVersion($s) {
		if(!thx_semver__Version_Version_Impl_::$VERSION->match($s)) {
			throw new HException("Invalid SemVer format for \"" . _hx_string_or_null($s) . "\"");
		}
		$major = Std::parseInt(thx_semver__Version_Version_Impl_::$VERSION->matched(1));
		$minor = Std::parseInt(thx_semver__Version_Version_Impl_::$VERSION->matched(2));
		$patch = Std::parseInt(thx_semver__Version_Version_Impl_::$VERSION->matched(3));
		$pre = thx_semver__Version_Version_Impl_::parseIdentifiers(thx_semver__Version_Version_Impl_::$VERSION->matched(4));
		$build = thx_semver__Version_Version_Impl_::parseIdentifiers(thx_semver__Version_Version_Impl_::$VERSION->matched(5));
		$this1 = _hx_anonymous(array("version" => (new _hx_array(array($major, $minor, $patch))), "pre" => $pre, "build" => $build));
		return $this1;
	}
	static function equals($this1, $other) {
		$tmp = null;
		$tmp1 = null;
		if($this1->version[0] === $other->version[0]) {
			$tmp1 = $this1->version[1] !== $other->version[1];
		} else {
			$tmp1 = true;
		}
		if(!$tmp1) {
			$tmp = $this1->version[2] !== $other->version[2];
		} else {
			$tmp = true;
		}
		if($tmp) {
			return false;
		}
		return thx_semver__Version_Version_Impl_::equalsIdentifiers($this1->pre, $other->pre);
	}
	static function greaterThan($this1, $other) {
		$tmp = null;
		if($this1->pre->length > 0) {
			$tmp = $other->pre->length > 0;
		} else {
			$tmp = false;
		}
		if($tmp) {
			$tmp1 = null;
			$tmp2 = null;
			if($this1->version[0] === $other->version[0]) {
				$tmp2 = $this1->version[1] === $other->version[1];
			} else {
				$tmp2 = false;
			}
			if($tmp2) {
				$tmp1 = $this1->version[2] === $other->version[2];
			} else {
				$tmp1 = false;
			}
			if($tmp1) {
				return thx_semver__Version_Version_Impl_::greaterThanIdentifiers($this1->pre, $other->pre);
			} else {
				return false;
			}
		} else {
			if($other->pre->length > 0) {
				if($this1->version[0] !== $other->version[0]) {
					return $this1->version->a[0] > $other->version[0];
				}
				if($this1->version[1] !== $other->version[1]) {
					return $this1->version->a[1] > $other->version[1];
				}
				if($this1->version[2] !== $other->version[2]) {
					return $this1->version->a[2] > $other->version[2];
				}
				if($this1->pre->length > 0) {
					return thx_semver__Version_Version_Impl_::greaterThanIdentifiers($this1->pre, $other->pre);
				} else {
					return true;
				}
			} else {
				if($this1->pre->length <= 0) {
					if($this1->version[0] !== $other->version[0]) {
						return $this1->version->a[0] > $other->version[0];
					}
					if($this1->version[1] !== $other->version[1]) {
						return $this1->version->a[1] > $other->version[1];
					}
					if($this1->version[2] !== $other->version[2]) {
						return $this1->version->a[2] > $other->version[2];
					}
					return thx_semver__Version_Version_Impl_::greaterThanIdentifiers($this1->pre, $other->pre);
				} else {
					return false;
				}
			}
		}
	}
	static function greaterThanOrEqual($this1, $other) {
		if(!thx_semver__Version_Version_Impl_::equals($this1, $other)) {
			return thx_semver__Version_Version_Impl_::greaterThan($this1, $other);
		} else {
			return true;
		}
	}
	static function lessThan($this1, $other) {
		return !thx_semver__Version_Version_Impl_::greaterThanOrEqual($this1, $other);
	}
	static function lessThanOrEqual($this1, $other) {
		return !thx_semver__Version_Version_Impl_::greaterThan($this1, $other);
	}
	static function parseIdentifiers($s) {
		$tmp = null;
		if(null === $s) {
			$tmp = "";
		} else {
			$tmp = $s;
		}
		return _hx_explode(".", $tmp)->map((property_exists("thx_semver__Version_Version_Impl_", "sanitize") ? thx_semver__Version_Version_Impl_::$sanitize: array("thx_semver__Version_Version_Impl_", "sanitize")))->filter(array(new _hx_lambda(array(), "thx_semver__Version_Version_Impl__0"), 'execute'))->map((property_exists("thx_semver__Version_Version_Impl_", "parseIdentifier") ? thx_semver__Version_Version_Impl_::$parseIdentifier: array("thx_semver__Version_Version_Impl_", "parseIdentifier")));
	}
	static function parseIdentifier($s) {
		$i = Std::parseInt($s);
		if(null === $i) {
			return thx_semver_Identifier::StringId($s);
		} else {
			return thx_semver_Identifier::IntId($i);
		}
	}
	static function equalsIdentifiers($a, $b) {
		if($a->length !== $b->length) {
			return false;
		}
		{
			$_g1 = 0;
			$_g = $a->length;
			while($_g1 < $_g) {
				$_g1 = $_g1 + 1;
				$i = $_g1 - 1;
				{
					$_g2 = $b[$i];
					$_g3 = $a[$i];
					switch($_g3->index) {
					case 0:{
						if($_g2->index === 0) {
							$a1 = _hx_deref($_g3)->params[0];
							$b1 = _hx_deref($_g2)->params[0];
							if($a1 !== $b1) {
								return false;
							}
						}
					}break;
					case 1:{
						if($_g2->index === 1) {
							$a2 = _hx_deref($_g3)->params[0];
							$b2 = _hx_deref($_g2)->params[0];
							if($a2 !== $b2) {
								return false;
							}
						}
					}break;
					default:{}break;
					}
					unset($_g3,$_g2);
				}
				unset($i);
			}
		}
		return true;
	}
	static function greaterThanIdentifiers($a, $b) {
		{
			$_g1 = 0;
			$_g = $a->length;
			while($_g1 < $_g) {
				$_g1 = $_g1 + 1;
				$i = $_g1 - 1;
				$_g2 = $b[$i];
				$_g3 = $a[$i];
				switch($_g3->index) {
				case 0:{
					switch($_g2->index) {
					case 0:{
						$a1 = _hx_deref($_g3)->params[0];
						$b1 = _hx_deref($_g2)->params[0];
						if($a1 === $b1) {
							continue 3;
						} else {
							$a2 = _hx_deref($_g3)->params[0];
							$b2 = _hx_deref($_g2)->params[0];
							if((strcmp($a2, $b2)> 0)) {
								return true;
							} else {
								return false;
							}
						}
					}break;
					case 1:{
						return true;
					}break;
					default:{
						return false;
					}break;
					}
				}break;
				case 1:{
					if($_g2->index === 1) {
						$a3 = _hx_deref($_g3)->params[0];
						$b3 = _hx_deref($_g2)->params[0];
						if($a3 === $b3) {
							continue 2;
						} else {
							$a4 = _hx_deref($_g3)->params[0];
							$b4 = _hx_deref($_g2)->params[0];
							if($a4 > $b4) {
								return true;
							} else {
								return false;
							}
						}
					} else {
						return false;
					}
				}break;
				default:{
					return false;
				}break;
				}
				unset($i,$_g3,$_g2);
			}
		}
		return false;
	}
	static $SANITIZER;
	static function sanitize($s) {
		return thx_semver__Version_Version_Impl_::$SANITIZER->replace($s, "");
	}
	function __toString() { return 'thx.semver._Version.Version_Impl_'; }
}
thx_semver__Version_Version_Impl_::$VERSION = new EReg("^(\\d+)\\.(\\d+)\\.(\\d+)(?:[-]([a-z0-9.-]+))?(?:[+]([a-z0-9.-]+))?\$", "i");
thx_semver__Version_Version_Impl_::$SANITIZER = new EReg("[^0-9A-Za-z-]", "g");
function thx_semver__Version_Version_Impl__0($s1) {
	{
		return $s1 !== "";
	}
}
